/* LASERL.C - program to download LANDSCAPE fonts from WORD */

# define LINT_ARGS

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>

char *fontfiles[] = {
	"HPFONTS\\HV060BPN.R8L", /* 0 */
	"HPFONTS\\HV060IPN.R8L",	/* 1 */
	"HPFONTS\\HV060RPN.R8L",	/* 2 */
	"HPFONTS\\HV080BPN.R8L",	/* 3 */
	"HPFONTS\\HV080IPN.R8L",	/* 4 */
	"HPFONTS\\HV080RPN.R8L",	/* 5 */
	"HPFONTS\\HV100BPN.R8L",	/* 6 */
	"HPFONTS\\HV100IPN.R8L",	/* 7 */
	"HPFONTS\\HV100RPN.R8L",	/* 8 */
	"HPFONTS\\HV120BPN.R8L",	/* 9 */
	"HPFONTS\\HV120IPN.R8L",	/* 10 */
	"HPFONTS\\HV120RPN.R8L",	/* 11 */
	"HPFONTS\\HV140BPN.R8L",	/* 12 */
	"HPFONTS\\HV140IPN.R8L",	/* 13 */
	"HPFONTS\\HV140RPN.R8L",	/* 14 */
	"HPFONTS\\HV180BPN.R8L",	/* 15 */
	"HPFONTS\\HV240BPN.R8L",	/* 16 */
	"HPFONTS\\HV300BPN.R8L",	/* 17 */
	"HPFONTS\\TR060BPN.R8L",	/* 18 */
	"HPFONTS\\TR060IPN.R8L",	/* 19 */
	"HPFONTS\\TR060RPN.R8L",	/* 20 */
	"HPFONTS\\TR080BPN.R8L",	/* 21 */
	"HPFONTS\\TR080IPN.R8L",	/* 22 */
	"HPFONTS\\TR080RPN.R8L",	/* 23 */
	"HPFONTS\\TR100BPN.R8L",	/* 24 */
	"HPFONTS\\TR100IPN.R8L",	/* 25 */
	"HPFONTS\\TR100RPN.R8L",	/* 26 */
	"HPFONTS\\TR120BPN.R8L",	/* 27 */
	"HPFONTS\\TR120IPN.R8L",	/* 28 */
	"HPFONTS\\TR120RPN.R8L",	/* 29 */
	"HPFONTS\\TR140BPN.R8L",	/* 30 */
	"HPFONTS\\TR140IPN.R8L",	/* 31 */
	"HPFONTS\\TR140RPN.R8L",	/* 32 */
	"HPFONTS\\TR180BPN.R8L",	/* 33 */
	"HPFONTS\\TR240BPN.R8L",	/* 34 */
	"HPFONTS\\TR300BPN.R8L",	/* 35 */
	"HPFONTS\\LG095R16.R8L",	/* 36 */
	"HPFONTS\\LG120B12.R8L",	/* 37 */
	"HPFONTS\\LG120I12.R8L",	/* 38 */
	"HPFONTS\\LG120R12.R8L",	/* 39 */
	"HPFONTS\\LG140R10.R8L",	/* 40 */
	"HPFONTS\\LG095R16.M8L",	/* 41 */
	"HPFONTS\\LG120R12.M8L",	/* 42 */
	"HPFONTS\\PS140B10.USL",	/* 43 */
	"HPFONTS\\PS160B08.USL",	/* 44 */
	"HPFONTS\\PS180B06.USL",	/* 45 */
	"HPFONTS\\PS240B05.USL",	/* 46 */
	"HPFONTS\\PS300B04.USL"	/* 47 */
	};

int translationtable[][30] = {		/*  translates font size and style into a font number  
 12 12 12 16 16 16 19 19 19 20 20 20 24 24 24 28 28 28 32 32 32 36 36 36 48 48 48 60 60 60  pointsize*2
  B  I  N  B  I  N  B  I  N  B  I  N  B  I  N  B  I  N  B  I  N  B  I  N  B  I  N  B  I  N  bold, italic, normal */
{ 0, 1, 2, 3, 4, 5, 6, 7, 8, 6, 7, 8, 9,10,11,12,13,14,15,15,15,15,15,15,16,16,16,17,17,17},   /* Helvetica */
{18,19,20,21,22,23,24,25,26,24,25,26,27,28,29,30,31,32,33,33,33,33,33,33,34,34,34,35,35,35},   /* TmsRmn */
{36,36,36,36,36,36,36,36,36,36,36,36,37,38,39,40,40,40,40,40,40,40,40,40,40,40,40,40,40,40},   /* Letter Gothic */
{43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,44,44,44,45,45,45,46,46,46,47,47,47},   /* Presentations */
{41,41,41,41,41,41,41,41,41,41,41,41,42,42,42,42,42,42,42,42,42,42,42,42,42,42,42,42,42,42}    /* Math 8 */
	};

main (argc, argv)
int argc;
char *argv[];

{int c, i, bold, italic, font, fontnumber, fontsize;
int  size, style, idx, idnumber;
char filename[20];
FILE *ifp;

printf("Font Downloading Program\n\n");

/* advance the argument pointer to the specification list */
argv++;

/* check that designated printer is correct */
if ((int)**argv != 0x01)
	{printf("Printer does not exist\n");
	exit(1);
	}

/* check for 2 unused bytes of FF */
(*argv)++;	/* next byte */
for (i=0; i<2; i++)
	if ((int)**argv != -1)
		{printf("Unexpected 2nd or 3rd byte\n");
		for (i=0; i<30000; i++) ;	/* give the operator a chance to see it */
		exit(1);
		}
	else
		(*argv)++;	/* next byte */

/* set the translation mode to binary */
setmode (fileno(stdprn), O_BINARY);

/* clear the printer of all previous fonts */
fprintf(stdprn,"\x1B*c0F");
idnumber = 1;	/* initial font idnumber */

while (--argc > 0)	/* loop thru argument lists */
	{while (**argv != NULL)
		{fontnumber = (int)(**argv & 0x3f);
		italic = (**argv & 0x40) ? 1 : 0;
		bold = (**argv & 0x80) ? 1 : 0;
		style = 2;		/* default is regular */
		if (italic)
			style = 1;	/* select italic style */
		if (bold)
			style = 0;	/* bold italic is not supported, so bold overrides italic */
		(*argv)++;		/* next byte */
		fontsize = (int)**argv;

/* there is a problem with the call to this routine by WORD when the point-size of the 
typeface is 16 (i.e. FontSize: 32 in the PRD file) in that the command string terminates 
prematurely with a byte of 00 and continues with the next argv.  In that case, do not 
advance the byte-pointer thus allowing this loop to terminate. */
		if (fontsize == 0)
			fontsize = 32;	/* correct the artifact in the calling sequence */
		else
			(*argv)++;		/* next byte */

/* determine size as a displacement into the translation table */

		switch (fontsize)		/* fontsize is 2x actual points */
			{case 12:
				size = 0;
				break;
			case 16:
				size = 3;
				break;
			case 19:
				size = 6;
				break;
			case 20:
				size = 9;
				break;
			case 24:
				size = 12;
				break;
			case 28:
				size = 15;
				break;
			case 32:
				size = 18;
				break;
			case 36:
				size = 21;
				break;
			case 48:
				size = 24;
				break;
			case 60:
				size = 27;
				break;
			default:
				size = 9;		/* 12 point */
			};

/*  add in the style - bold, italic, or normal */
	size += style;

/* select the fontnumber which is the row in the translation table */

		switch (fontnumber)
			{case 0:		/* Courier */
				goto bypass;	/* no downloading required */
				break;
			case 2:		/* Compressed LinePrinter */
				goto bypass;	/* no downloading required */
				break;
			case 4:		/* Presentations */
				font = 3;
				break;
			case 6:		/* Letter Gothic */
				font = 2;
				break;
			case 8:		/* Helvetica */
				font = 0;
				break;
			case 16:		/* TmsRmn */
				font = 1;
				break;
			case 56:		/* Math 8 */
				font = 4;
				break;
			default:
				goto bypass;
			}
		idx = translationtable[font][size];

/* assign the font an id number to prevent overwriting */
		fprintf(stdprn, "\x1B*c%dD", idnumber);

/* download the font */
		printf("Downloading font %d:  %s\n", idx, fontfiles[idx]);
		if ((ifp = fopen(fontfiles[idx],"rb")) == NULL)
			printf("Cannot open the font file\n");
		else
			{while ((c = fgetc(ifp)) != EOF)
				if (fputc(c, stdprn) == EOF)
					{printf("Printer error\n");
					for (i=0; i<30000; i++) ;	/* give the operator a chance to see it */
					exit(1);
					}
			fclose(ifp);
			}

/* make the font temporary */
		fprintf(stdprn, "\x1B*c%dD\x1B*c4F", idnumber);

/* advance the idnumber */
		idnumber++;

	bypass:;
	}
argv++;	/* advance argument pointer to next list */
}
fcloseall();
exit(0);
}
